<template>
  <div>
    <div v-show="!searchRunning">
      <b-list-group>
        <b-list-group-item
          v-for="vocabularyTerm in vocabularyTerms"
          :id="'vocab' + vocabularyTerm.uri.replace(/[\/.#:]/g, '')"
          :key="vocabularyTerm.uri"
          v-b-tooltip.hover.noninteractive.left="{
            customClass: 'vocabularyTooltip',
            title: `${vocabularyTerm.label}: ${getDescription(vocabularyTerm)} (${vocabularyTerm.uri})`,
          }"
          button
          class="d-flex justify-content-between align-items-center draggable vocabList"
          :draggable="!readonly"
          :disabled="readonly"
          @click="addVocabularyTerm(vocabularyTerm)"
          @dragstart="startDrag($event, vocabularyTerm)"
        >
          <b-row align-v="center" style="width: 100%">
            <b-col
              cols="auto"
              align-self="stretch"
              class="text-start me-auto right-padding"
            >
              {{
                vocabularyTerm.prefix !== undefined
                  ? vocabularyTerm.prefix + ":"
                  : ""
              }}{{ vocabularyTerm.short_form }}
            </b-col>
            <b-col cols="auto" align-self="end" class="text-end right-padding">
              <b-badge variant="success" pill class="add">+</b-badge>
            </b-col>
          </b-row>
        </b-list-group-item>
      </b-list-group>
      <div class="grayed">
        <p v-if="vocabularyTerms.length === 0">{{ $t("emptyVocabList") }}</p>
        <hr />
        <b-button :disabled="readonly" @click="addCustomTerm">{{
          $t("addCustomTerm")
        }}</b-button>
      </div>
    </div>
    <ListGroupSkeletons v-show="searchRunning" />
  </div>
</template>

<script lang="ts">
import VocabularyTerm from "@/types/vocabulary-term";

import { defineComponent, type PropType } from "vue";

import { generateTermUri } from "@/util/linkedData";

export default defineComponent({
  name: "ListVocs",
  props: {
    readonly: {
      default: false,
      type: Boolean,
    },
    searchRunning: {
      default: false,
      type: Boolean,
    },
    vocabularyTerms: {
      required: true,
      type: Array as PropType<VocabularyTerm[]>,
    },
  },
  methods: {
    addCustomTerm() {
      this.addVocabularyTerm({
        short_form: "custom",
        uri: generateTermUri(),
      });
    },
    addVocabularyTerm(vocabularyTerm: VocabularyTerm) {
      this.$emit("addVocabularyTerm", vocabularyTerm);
    },
    getDescription(vocabularyTerm: VocabularyTerm): string | undefined {
      if (vocabularyTerm?.description) {
        if (vocabularyTerm.description[this.$i18n.locale as "en" | "de"]) {
          return vocabularyTerm.description[this.$i18n.locale as "en" | "de"];
        } else if (vocabularyTerm.description["en"]) {
          return vocabularyTerm.description["en"];
        }
      }
      return "";
    },
    startDrag(event: DragEvent, vocabularyTerm: VocabularyTerm) {
      if (event.dataTransfer !== null) {
        event.dataTransfer.dropEffect = "move";
        event.dataTransfer.effectAllowed = "move";
        event.dataTransfer.setData(
          "vocabularyTerm",
          JSON.stringify(vocabularyTerm),
        );
      }
    },
  },
});
</script>

<style>
.cardRow .list-group button.vocabList.list-group-item-action,
.cardRow .list-group a.vocabList.list-group-item-action {
  padding-right: 0px;
}
.vocabularyTooltip .tooltip-inner {
  max-width: 300px;
}
</style>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.draggable:hover {
  cursor: grab;
}
.grayed {
  color: gray;
}
.right-padding {
  padding-right: 0px;
}
</style>
